# 1.3.5

- Added extra failsafes to Modulars passive code to prevent it from throwing errors (even though realistically it shouldnt be throwing them ever.)
- Fixed bug with Singularity Pulsar Weapons that made them make enemy bullets not collide with the player.
- Fixed bug where the Shrapnel Launcher had a much higher chance of being selected by the Random Weapon button.
- Hopefully added enough failsafes to stop a certain error from appearing.
- Moved changelog to separate changelog file.

- Now leave me to my lotions.

# 1.3.4

- Removed some debug code that made Linux versions not be able to use the mod

# 1.3.3

- Looked over and fixed hopefully all inconsistencies between the descriptions of modules and their actual ingame effects. This is also partly a nerf to some modules.
- Tweaked the values of some modules.
- Tweaked the values of The Hammer and Shield Generator.
- Modules like Perfect Replica now properly display the additional stacks they provide in your inventory.
- Updated the visual effect of Fake / Temporary modules being added / removed. This should make it clearer when new ones are added / removed.
- Added a more visible burning trail to Hyper Propellant.
- Removed Critical Hits as a mechanic nearly completely, either by removing modules outright or removing Crits as a secondary effect from modules. The Turkey still keeps its effect, but its item tips description has been reworded.
- Crits were a feature I thought would be interesting but ended up adding extra "on hit / fire" modules to the pool which I wasn't a fan of, and by themselves were just lame / confusing to the player, as what they did wasn't directly evident.


# 1.3.2

- Added some failsafes in the code of new guns
- Hopefully fixed some startup errors.

# 1.3.1

- Fixed potential errors on game load due to weird save data.
- Investigating potential issues with Modular and custom chests. If you know more tell me in the Gungeon Modding Discord.

# 1.3.0

New:
- Added interaction with Gun Munchers.
- Pink Guon Stone now synergizes with Modular
- Turkey now synergizes with Modular.

- Elimentaler now drops a Block Of Cheese. Massive gameplay ramifications.

Weapons:
- Random (Selects a random unlocked weapon in your arsenal)
- ???
- ???
- ???

Modules:

Tier 1:
- Temporary Shield
- Vorpal Rounds
- Heavy Hitter
- Supply Drop
- Overcharged Capacitor
- Explosive Energy

Tier 2:
- Pace Breaker
- Lucky Shot
- Sided Operation
- Focused Retaliation
- Solar Flare
- Chaotic Transportation

Tier 3:
- Pin-point Strike
- Eternal Wrath
- Iterated Design

Tier ?????:
- ????? ?????
- ?????? ?????????


Module Changes:
- Many modules were tweaked, changed up and 1-2 were reworked. This is to combar power creep and to make certain usually less appealing modules more appealing.

- Patient Zero can only proc its on-hit effect onto a specific enemy a maximum of 3 times. The on-kill effect does not take this cap into consideration.


Balances Changes:
Synergy items that give power now give half as much power. Master Rounds are unaffected, and so are Power Cells
- Guon Stones are no longer scrapped for 2 Scrap by default. This is a direct nerf to scrapping glass guon stones.
- Reworked Hunter Seeker Module
- Reworked Mirrored Software slightly

- Adjusted module scrap costs for Crafting.
- A pass has been done over all modules to adjust how common they are, and fix up some weights that were not applied properly.
- Certain modules can no longer appear in Blessed Mode.
- Certain modules can no longer appear in Rainbow Mode.

-Weapon Changes
- The Hammer got massively buffed.
- Slightly nerfed the Precision Rifle
- Shrapnel Launcher now shoots 1 extra piece of shrapnel. Shrapnel spreads out in a circular formation instead of a cone.
- Reworked Quad Burster into the Auto Burster
- Adjusted Artemis and Apollo damage values
- Charge Blasters small projectile now has much more force and speed

-Past:
- Made Sentry Turret laser sight affected by collision. This means it will stop at walls / other objects.
- Attempted fix at Laser Diode deaths breaking the AI of other Laser Diodes.
- Fixed bug in Past boss where the landing reticle would stop rendering, making predicting where it would land very difficult.
- Tweaked multiple rooms. 
- Fixed small visual bug related to Energy Shield enemies. 

Fixes:
- Fixed bug where the room icon for Scrap would randomly appear in a room without there actually being Scrap there.
- Fixed bug in Patient Zero that made it not deactivate its on-kill effect when being fully unpowered.
- Fixed Minelayer System having its mines near-instantly arm.

Misc:
- Tweaked some of the Modulars default skin sprites.
- Tweaked the intensity of more visual effects 
- Added more visual effects to the pool of those that can get disabled.
- Added notifications for when new weapons are unlocked
- Added player Scrap count to the Crafting Cores UI


# 1.2.9

- Tweaked some weapons even more.
- Made flak-shot function more intuitively.
- Hopefully? fixed eldritch tileset bug in the Past.

# 1.2.8

- Tweaked the cost of Upgrading Power.
- Buffed Light Lance a bit.
- Buffed Volatic Tethers a little bit.
- very slightly tweaked the Shrapnel Launcher.
- Tweaked code for Voltaic Tethers and Lightning Nets

# V.1.2.7

- The Hammers Active Reload should now actually work.
- Fixed inconsistency between The Hammer variants reload times.
- Nerfed the Scatter Blast.

# V.1.2.6

# Weapon Changes
- The Hammer
- Active reload trigger has been moved to the center of the bar. In turn, the damage has been slightly buffed.
- Flak Cannon
- Fire Rate slightly reduced, reduced damage and split count.
- Kinetic Payload
- Now has a starting penalty of -2 Power.

# Module Changes
- Flak Shot now scales less strongly.
- Tweaked Uncontrollable Burst' stats.
- Reduced Bifurcated Barrels Stat gains slightly.
- Buffed Hellfire Launchers range + damage.
- Reduced Laser Lances base damage.
- Buffed Perfectionist Momentum
- Greatly buffed Refunded Components
- Greatly reduced Sticky Bombs explosive damage.
- Increased Five-Shot Salutes stat reductions.
- Machine Instinct now scales a bit less.
- Nerfed The Swarm a considerable amount.

# Fixes
- Fixed some inconsistent text (Thank you Lynceus)
- Fixed a few issues with Quantum Leap.
- Made the game not immediately shit itself if you have Flak Shot with The Shrapnel Launcher.


# V.1.2.5

- Tweaked Flak Shot code to be a bit more synergistic with certain Modules.
- Buffed Burning Hell slightly.
- Fixed typo on Cleaning Protocol description.

# V.1.2.4

- Hopefully fixed language-specific mod load failure.


# V.1.2.3

- Updated code for Bifurcated Barrel And Five-Shot Salute.
- Fixed Bifurcated Barrel And Five-Shot Salute potentially functioning in the Past.
- Other small changes

# V.1.2.2

- Fixed bug where the Modular would get no starter weapon in their Past.
- Added 4 new configs. Load the game once and close it to have them appear in the config manager. 
- Visual Effects: Toggles certain visual effects.
- Important VFX Intensity: Tweaks the intensity of certain visual effects.
- Distortion Wave Intensity: Tweaks teh intensity of distortion wave effects.
- Afterimage Lifetime Multiplier: Tweaks the lifetime of afterimage effects.

-Note, what these configs affect isn't fully comprehensive and will be updated when required.

# V.1.2.1

- Fixed some weapon inconsistencies.

# V.1.2.0
# New
- Added 2 new starter weapons.
- Added 5 New Modules:

- Flak Shot
- Uncontrollable Burst
- Tachyon Warp
- Bifurcated Barrel
- Quantum Leap

# Changes
- Reduced Peashooter damage from 5 -> 4.5

# QoL
- Ammo pickups sold in the shop are now turned into Scrap.
- Added power visualisation to the Inventory. No more power mental gymnastics.
- Added range visual indicator for Reactive Sensors.
- Tweaked brightness of Focusing Lens & Calibrated Lens range indicators.


# Misc
- Added item tips description to Predefined Drive.
- Tweaked projectile stuff.



# V.1.1.13

- Hopefully added final fix to co-op stuff. If stuff keeps breaking after this I'm not sure Ill bother fixing it as I have no proper way to test co-op stuff

# V.1.1.12

- Small internal changes

# V.1.1.11

- Hopefully fixed Tank Carapace from just not working right. I still have no idea why it didn't.

# V.1.1.10

- Changed code in Singularity Pulsars rift projectiles to clear distortion if they stick to a surface via sticky projectile behaviors.
- Fixed typo in Past Bosses dialogue.
- Another few very small things

# V.1.1.9

# Changes
- If a sticky projectile effect is rolled by Chance Bullets while playing as Modular, it should now function properly.
- Added A

# V.1.1.8
- Hopefully fixed weird issue with somehow getting every alt weapon at once.
- Placed alternate Singularity Pulsar variant into excluded tier.
- Tweaked carry offset of the alternate default arm cannon.
- Fixed several visual issues with the alternate Light Lance variant.

# V.1.1.7

# New
- Added new item: Predefined Drive

# Changes
- Overhauled the first 2 rooms of the Modulars Past, with new decoratives, and other things.
- Added a few small things. :)
- Added some special icons in certain places, spritework courtesy of Lynceus.

# Fixes
- A few small things


# V.1.1.6

- EVEN MORE CO-OP FAILSAFES I CANT FUCKING TEST PROPERLY.
- FUCK.

# V.1.1.5

- Another minor UI tweak.
- A module fix.
- Don't ever ask me to fix that god damned UI again.

# V.1.1.4
- Globalized Scrap pickups because i forgot coop players share pickups
- Added coop failsafe to Modulars past where non-modular characters get a dart gun
- All of modulars starters should now persist past death in co-op
- Hopefully fixed potential visual bug if a gun that was indicated to be turned into modules was picked up by another player
- Tweaked modular inventory size scaling based on screen resolution, hopefully for the last fucking time
- Fixed cleaning protocol breaking the game against Dragun


- Please never ask me about controller support. Please.

# V.1.1.3

#### Fixes:
- Fixed Page turn button not working due to an oversight
- Cleaned up error from selecting modules occasionally
- Hopefully fixed weird sprite offset with cleaning protocol
- Fixed bug where pausing and unpausing after crafting would recraft modules for free

#### Misc:
- Tweaked Nopticon body hitbox
- Temporary Module counts are now displayed with an orange color to be more consistent with the rest of the UI

# V.1.1.2

- Kill me.
- Fixed a thing idk im tired of this already

# *V.1.1.1*

#### Fixes:
- Fixed Confidence Drives being repeatedly encounterable in the shop as Modular.
- Updated README
- Fixed a bug with blessed mode modular that would remove weapons when it shouldnt
- Hopefully fixed bug with temporary modules that makes them not go away if you got 2 of the same temporary module
- Fixed Artemis and Apollo not scaling with fire rate upgrades like intended
- Fixed Artemis And Apollo just, not fucking working properly at all


# *V.1.1.0*

#### New Item
- Confidence Drive (Unlocked by beating the Dragun as Modular)


#### New Modules
- Heavyweight Rounds
- Cleaning Protocol
- Phantasm Boost
- Heat Vectoring
- Table Kinetics
- Tank Carapace
- [TO_DO, Remember to fill this one out!!!]
- [???]

#### Blessed Mode
- Now functions completely uniquely for the Modular. Give it a try! 


#### Quality Of Life

- Modules that affect rate of fire now affect how fast charge weapons charge.
- Added new button to the Module Inventory that displays tips.
- Added minimap icons for Modules, Scrap and Crafting Cores.
- Updated gun nudge mechanic into a proper gun tethering mechanic
- Tweaked Power Capacity text box in the Module Inventory to make it more clear that it's interactable.


#### Module Changes

##### Machine Instinct
- Lowered Risk buildup speed
- Increased ability cooldown from 5s => 10s 
- (Note: 5 seconds was too low what was I thinking lol)
##### The Scavenger
- Replaced extra scrap from scrapping mechanic with the ability to scrap guns.
- Reduced movement bonus from 5% => 2.5%
- (Note: This module was always a free take as it benefitted you 99% of the time. By giving you a choice it should now be less of a guaranteed pick, and actually gives a bit of extra thought to scrapping.)
##### Laser Lance
- Increased Laser Lance laser damage
- Removed 1 Bounce
##### Burning Hell
- No longer reduces clip size.
- Added new Accuracy bonus
##### Rubber Fillings
- Increased bounce count from 1 (1) => 2 (2)
- Added slight accuracy penalty
##### Repair Kit
- Damage reduced back to 15% (15%)
- Energy cost lowered from 1 (0.5) => 0.5 (0.25)
##### Aggresive Reload
- Can now push away projectiles, with precise timing.
##### Reactive Sensors
- Can now push away projectiles, with precise timing.
##### One Shot
- Fixed rounding in the stat processing, should now consistently apply its +1 Clip size benefit.
##### Sticky Bomb
- Tweaked detonation time to be more true to its description.
##### Recycling Nanites
- Should now have a sound effect and visual effect when triggered.
##### Impact Power
- Increased bounce count from 1 => 2
##### Glass Generator
- Grants a small fire rate bonus per Glass Guon Stone.
- (Note: This module is good, but was always left off until needed. This incentives keeping it active a bit more.)
##### Mercy Rounds
- Now spread the slain enemies debuffs when the enemy is killed.
- (Note: This module was always very niche, but along with a new module and this buff it should see more use now.)
##### Patient Zero
- Added effect blacklist to its hit-effect
- (Note: The blacklist was present for the on-kill effect, but not the on-hit. Oops.)
##### Misc.
- Altered the rarity of some special modules.

##### Past
- Increased Past boss HP from 550 => 675

##### Fixes

- Fixed the weapon crates hitbox being stupidly large.
- Fixed weird sprite offset with Burning Hell module.
- Fixed Regenerative Plating having its effect values switched around. It should now give stacking armor per floor and a consistent 1 Armor when scrapping. 

# V.1.0.11

- Fixed Mirrored Software picking modules that the player did not have active, negating Mirrored Softwares effect completely.

- Perfect Replica has had some VFX added.

- AAAAAAAAAAAAAAAAAAAAAAAAAA

# V.1.0.10

- Removed weird screenshake from the Hammer hopefully kill meeeeeeeee

# V.1.0.9

# Fixes

- Pea Shooter now gives the intended 1 Additional Power instead of 2. 
(*Note: It used to be 2 while in development but I decided to change it to one at some point, but forgot to update the weapons power stat.*) 

- Gone over every module necessary and added a check to hopefully prevent them from breaking on the Dragun fight.

- Laser Lance lasers should now follow sticky projectiles properly.

- Sticky projectiles with bouncing properties should hopefully not act weird anymore when hitting a wall sometimes.

- Voltaic Tethers should hopefully no longer throw out errors.

- Aggressive Reload should now have a sound effect, like it was always supposed to have.


## Module Changes

- Monetary Value

-- Casings gained per floor no longer scales with the amount of stacks of Monetary Value you have.

-- Casings gained per floor increased from 1.2x -> 1.25x

-- Note (*As funny as this module is, it gives very easy multiplicatively growing power for very cheap*)


- The Scavenger

-- Readded the damage bonus. Now gives 5% (+5%) damage per Scrap. 

-- Additional Scrap gains no longer scale with how many stacks of The Scavenger you have.

-- Clip size bonus now works like other clip size multipliers.

-- (*Note: with how good it was on release, and with how many times I've changed it already, I dont want it to be an instant take, but also dont want it to be hot garbage, so I readded the damage up to counterbalance all other nerfs it has gotten. Though it'll likely still stay an instant-take by most. :P*)


- Regenerative Plating

-- Armor gain when scrapping pickups no longer scales with the amount of Regenerative Platings you have. 

-- (*Note: the change to Regenerative Plating giving Armor when scrapping was done very late, and I forgot to consider that players will end up scrapping a lot more than floors they clear. This change still makes it usable but now Regenerative Platings main feature IS the armor per floor.*)

- Repair Kit

-- Damage bonus increased from 15% (15%) to 20% (20%).

-Disabled Dampeners

-- Made its recoil scale a lot less with your projectiles damage.

-- (*Note: I don't expect people to always genuinely consider taking this module, but it should hopefully be a bit more usable now.*)


- The Swarm

-- Stacking should now provide a tighter turn angle and detection radius

- Redirect System

-- Projectiles fired with Redirect System now have a "dead time" of 0.15 seconds when they spawn where they cannot be affected by redirects.

-- (*Note: this change will only really be noticeable with shotguns, as it prevents the projectiles from clustering up into a ball.*)

- Voltaic Tethers

-- Changed max connections from 2 -> 3

- Laser Lance

-- Should now function more intuitively with sticky projectiles.

- Recycling Nanites

-- Damage increase per hit increased from 3.3% -> 5%

# V.1.0.8

- Fixed the Past having no music because Gungeon code is stupid.
- Tweaked RNG Manipulation.

# V.1.0.7
- Fixes
- Fixed Monetary Value literally not doing anything

- Module Changes

- Disabled Dampeners
- Reduced recoil from Disabled Dampeners
- Buffed reload time decrease from 10% to 12.5%

- Hyper Propellant
- Rewritten the air ignition code, ignition effect should now consistently ignite the air regardless of projectile speed

- Radar Scanner
- Now reveals secret rooms if you are in an adjacent room to it

- Concussive Tips
- Fixed inaccurate knockback stat description

-Tweaked a couple of descriptions.

# V.1.0.6
- Hopefully prevented the starter active item from every being dropped. The work around is kinda jank and *may* break so tell me if it does and how.

# V.1.0.5
- Modules Changes

--Overclocked Magazines
-Reduced spread multiplier from 3x -> 2.5x

--Five-Shot Salute
-Buffed stacking effect from +1 Projectile to +2 Projectiles

--Voltaic Tethers
- Added ability for projectiles to pierce enemies
- Added ability for projectiles pierce small debris
- Tether nodes can only have a MAXIMUM of 2 Connections, to prevent lag.
- Buffed damage from 12 DPS -> 15 DPS
- Increased node-to-node range

--Lightning Nets
- Slightly increased tether range
- Tethers can now only have a MAXIMUM of 3 Connections, to prevent lag

--Mercy Rounds
- Buffed damage donus from 33% (+33%) -> 50% (+50%)

--Impact Power
-Fixed incorrect scaling damage value in its description.

--The Marksman
- Fixed incorrect Ammonomicon entry.

- Fixes
- Hopefully fixed flickering in the UI when picking up casings.
- Hopefully made the cursor visible on controller in the Gun Selection UI


# V.1.0.4
- Features
- Added new synergy with the Sprun.

- Module Changes

--The Swarm
- To slightly compensate for a fix, The Swarm has recieved a very minor damage buff.

--Ultra Ricochet
- Now doubles player projectile speed.

--Bubble Blast
- Projectiles will be reduced to 6.66% of their base speed instead of 10%.
- After reloading, projectiles will be 25% faster than their base speed.

--The Scavenger
- Removed damage bonus completely.
- Increased energy usage from 1 (0.5) to 2 (1)
- Reduced movement speed bonus from 10% to 5%

- Changes
- The game can now be paused in the Inventory UI. This will automatically close the UI.
- Changed some text to fit more appropriately to what the story of the Modular is.

- Fixes
- Fixed Modules not being lost when entering the Past, hopefully.
- Fixed Regenerative Plating from not granting the armor bonus when scrapping pickups or items.
- Fixed Ultra Ricochets explosions from dealing damage.
- Fixed unintentional damage scaling with The Swarm.
- Fixed a grammatical error in Emergency Reponse

# V.1.0.3
- Fixed a small oversight that could prevent certain inventory-based UI elements from disappearing properly.
- Added the ability to pierce through small debris objects to various unlockables.
- Added basic item tips support, mostly for some certain synergies.

# V.1.0.2
- Improved pickup detection logic for the Scrapper.
- Fixed the effect of a module from causing game-breaking errors.
- Removed some debug logging where there shouldn't be.

# V.1.0.1
- Updated README.

# V 1.0.0
- Initial release.




